#
# Berechnen der extrem schnell wachsenden Ackermannfunktion
#
###########################################

adict = dict()

def a(n, m):
    "rekursive Definition der Ackermannfunktion nach Peter"
    if n == 0:
        return m + 1
    elif m == 0:
        return a(n - 1, 1)
    else:
        global adict
        if (n, m) in adict:
             return adict[(n, m)]
        
        res = a(n - 1, a(n, m - 1) )
        adict[(n, m)] = res
        return res

# Die Rekursionsanzahl waechst so schnell, dass
# mehr Stack benoetigt wird
import sys
sys.setrecursionlimit(1000000)

for n in range(0,5):
    for m in range(0, 5):
        print "a(", n, ",", m, ") = ", a(n, m)
