#
# Eine einfache Turingmaschine in Python
#
# Einfuegen einer 1 am Anfang
############################################################

# das Band mit der Eingabe
tape=[1, 1, 1, 0]

# der aktuelle Zustand (s am Anfang)
state="s"
# die aktuelle Position (1. Zeichen am Anfang)
position=0

while state != "halt":
    # aktuelles Zeichen auf dem Band holen
    character = tape[position]

    # Ueberfuehrung fuer jeden Zustand und jedes Bandzeichen
    if state == "s":
        if character == 0:   state = "A";    character = 1;    move = 1
        elif character == 1: state = "B";    character = 1;    move = 1
        else:                state = "halt"; character = None; move = 0
    elif state == "A":
        if character == 0:   state = "A";    character = 0;    move = 1
        elif character == 1: state = "B";    character = 0;    move = 1
        else:                state = "halt"; character = 0;    move = 1
    elif state == "B":
        if character == 0:   state = "A";    character = 1;    move = 1
        elif character == 1: state = "B";    character = 1;    move = 1
        else:                state = "halt"; character = 1;    move = 1

    # Zeichen schreiben
    tape[position] = character

    # Leseposition anpassen
    position = position + move
    # Achtung am Ende des Bands!
    # Band erweitern
    if position >= len(tape):
        tape.append(None)

# Das fertige Band ausgeben
print tape
