#
# Eine einfache Turingmaschine in Python
#
# Einfuegen einer 1 am Anfang
#
# jetzt mit Ueberfuehrungsfunktion in einen Dictionary.
# Quasi eine "universelle Turingmaschine"
#
############################################################

# das Band mit der Eingabe
tape=[1, 0, 0, 1, 0]

# der aktuelle Zustand (s am Anfang)
state="s"
# die aktuelle Position (1. Zeichen am Anfang)
position=0

# Ueberfuehrungsfunktion
d = { ("s", 0):    ("A", 1, 1),
      ("s", 1):    ("B", 1, 1),
      ("s", None): ("halt", None, 0),
      ("A", 0):    ("A", 0, 1),
      ("A", 1):    ("B", 0, 1),
      ("A", None): ("halt", 0, 1),
      ("B", 0):    ("A", 1, 1),
      ("B", 1):    ("B", 1, 1),
      ("B", None): ("halt", 1, 1) }

while state != "halt":
    # aktuelles Zeichen auf dem Band holen
    character = tape[position]

    state, character, move = d[state, character]

    # Zeichen schreiben
    tape[position] = character

    # Leseposition anpassen
    position = position + move
    # Achtung am Ende des Bands!
    # Band erweitern
    if position >= len(tape):
        tape.append(None)

# Das fertige Band ausgeben
print tape
