#
# Berechnen der extrem schnell wachsenden Ackermannfunktion
#
###########################################

def a(n, m):
    "rekursive Definition der Ackermannfunktion nach Peter"
    if n == 0:
        return m + 1
    elif m == 0:
        return a(n - 1, 1)
    else:
        return a(n - 1, a(n, m - 1) )

def af(n):
    "Spur der Ackermannfunktion"
    return a(n, n)

# Die Rekursionsanzahl waechst so schnell, dass
# mehr Stack benoetigt wird
import sys
sys.setrecursionlimit(100000)

for n in range(1,4):
    print af(n)

print a(3,4)
print a(4,1)
