#
# einfacher 2D-Plot des Histogramms
#
###################################

import numpy as np

import matplotlib
import matplotlib.pyplot as pyplot

# Histogramm einer Normalverteilung erzeugen
zz = np.random.normal(0, 2, 1000000)
bins, raender = np.histogram(zz, bins=100)
# und die Mitten der Intervalle ausrechnen
mitten = 0.5*(raender[1:] + raender[:-1])

# malen
pyplot.plot(mitten, bins, "g", linewidth=2)
# und anzeigen
pyplot.show()
